(function(angular, $, _) {

	angular.module('form_processor').directive('crmFormProcessorInputs', function(formProcessorFactory, dialogService, $timeout) {
	  return {
	    restrict: 'E',
	    scope: {
	      inputs: '=',
	      formProcessor: '=',
	      deletedInputs: '=',
	      entity: '@',
        addButtonLabel: '@',
        addDropdownLabel: '@',
        dialogTitle: '@'
	    },
	    templateUrl: '~/form_processor/inputs/crmFormProcessorInputs.html',
	    link: function($scope, element, attrs){
	    	$scope.ts = CRM.ts(null);

	    	$scope.new_id = -1;

	    	$scope.inputTypes = angular.copy(CRM.form_processor.inputTypes);
			  for(var i=0; i<$scope.inputTypes.length; i++) {
			  	if ($scope.inputTypes[i].description) {
			  		$scope.inputTypes[i].description = $sce.trustAsHtml($scope.inputTypes[i].description);
			  	}
			  }

			  $timeout(function(){
		    	// The select boxes for input type and action type do not count for the @pristine state of the
		    	// form.
		  		$scope.formProcessorInputsForm.type.$pristine = false;
				});

	    	$scope.removeInput = function removeInput(input) {
		    	var index = $scope.inputs.indexOf(input);
		    	if (index >= 0) {
		    		$scope.inputs.splice(index, 1);
		    		$scope.deletedInputs.push(input);
		    	}
		    	$scope.formProcessorInputsForm.$setDirty();
		    };

		     // Open a dialog for adding an input
		    $scope.addInput = function addInput(inputType) {
		    	if (!inputType) {
		    		return;
		    	}
		    	var input = {
		    		'id': $scope.new_id,
		    		'type': angular.copy(inputType),
						'title': '',
		      	'name': '',
		  			'is_required': 0,
		  			'default_value': '',
		  			'validators': [],
		  			'configuration': angular.copy(inputType.default_configuration),
		    	};
		      $scope.editInput(input);
		    };

		    // Open a dialog for editting an input
		    $scope.editInput = function editInput(input) {
		      var options = CRM.utils.adjustDialogDefaults({
		        autoOpen: false,
		        width: '40%',
		        height: '80%',
		        title: $scope.dialogTitle ? $scope.dialogTitle : ts('Edit input')
		      });
		      index = $scope.inputs.indexOf(input);
		      var model = {
		      	formProcessor: $scope.formProcessor,
		      	inputs: $scope.inputs,
		      	input: input,
		      	entity: $scope.entity
		      };
		      dialogService.open('InputDialog', '~/form_processor/inputs/InputDialogCtrl.html', model, options)
		      .then(function(data) {
		      	$scope.formProcessorInputsForm.$setDirty();
		      	if (index >= 0) {
		      		$scope.inputs[index] = data.input;
		      	} else if ($scope.new_id == data.input.id) {
							$scope.inputs.push(data.input);
							$scope.new_id --;
						}
					});
		    };

	    }
	  };
	});

})(angular, CRM.$, CRM._);
